#Autogenerated class


from xml.dom.minidom import parseString

from bioMoby.mobyDataTypes import MobyString
from Interactor import MobyInteractor
from bioMoby.mobyDataTypes import MobyObject


class MobyInteraction(MobyObject):
    """ Description: An interaction object, in native BioMOBY format. It has one or more interactors, a method and a result
        Author: pdg.cnb.uam.es
        Contact: jmfernandez@cnb.uam.es
    """
    def __init__(self,namespace="",id="",Result="",ResultUnits="",Participant=[],articleName=""):
        self._articles={"Result":"result","ResultUnits":"resultUnits","Participant":"participant"}
        self.namespace=namespace
        self.id=id
        self.Result=Result
        self.ResultUnits=ResultUnits
        self.Participant=Participant
        self.__prefix__="moby"
        self.__tag__="Interaction"
        self.articleName=articleName


    def fromMoby(self, value):

        """ Load the attributes from an XML string
        """
        from bioMoby.mobyMarshal import MobyUnmarshaller
        doc=value
        if isinstance(value,str):
            doc=parseString(value).firstChild
        um=MobyUnmarshaller()
        self.content=""
        self.namespace=doc.getAttribute("moby:namespace")
        if self.namespace=="":
            self.namespace=doc.getAttribute("namespace")
        self.id=doc.getAttribute("moby:id")
        if self.id=="":
            self.id=doc.getAttribute("id")

        self.articleName=doc.getAttribute("moby:articleName")
        if self.articleName=="":

            self.articleName=doc.getAttribute("articleName")
        self.Participant=[]
        for elt in doc.childNodes:
            if elt.nodeType==elt.TEXT_NODE or elt.nodeType==elt.CDATA_SECTION_NODE:
                self.content=self.content+elt.nodeValue
            if elt.nodeName=="CrossReference" or elt.nodeName=="moby:CrossReference":
                self.__cross__=[]
                for ref in elt.childNodes:
                    self.__cross__.append(ref)
            if elt.nodeType==elt.ELEMENT_NODE and (elt.nodeName=="String" or elt.nodeName=="moby:String") and (elt.getAttribute("articleName")=="Result" or elt.getAttribute("moby:articleName")=="Result"):
                t=MobyString()
                t.fromMoby(elt)
                self.Result=t.content
            if elt.nodeType==elt.ELEMENT_NODE and (elt.nodeName=="String" or elt.nodeName=="moby:String") and (elt.getAttribute("articleName")=="ResultUnits" or elt.getAttribute("moby:articleName")=="ResultUnits"):
                t=MobyString()
                t.fromMoby(elt)
                self.ResultUnits=t.content
            if elt.nodeType==elt.ELEMENT_NODE and (elt.nodeName=="Interactor" or elt.nodeName=="moby:Interactor") and (elt.getAttribute("articleName")=="Participant" or elt.getAttribute("moby:articleName")=="Participant"):
                auxObject=MobyInteractor()
                auxObject.fromMoby(elt)
                self.Participant.append(auxObject)